package robocop;
import java.util.*;

/**
 *
 * @author Paul
 * @author Dirk
 */
public class GoalieBrain extends TheBrain
{

	/** siehe TheBrain
	 * @param netTraffic
	 * @param teamName
	 * @param playerNumber
	 * @param gui
	 */
	public GoalieBrain(NetTraffic netTraffic, String teamName, int playerNumber, int gui)
	{
		super(netTraffic, teamName, playerNumber, gui);
	}
	
	
	VisualObj getFocusWait(VisualObj obj)
	{
		if((obj != null)
			&& (obj.getXpos() != OUTBOUNDS)
			&& (obj.getYpos() != OUTBOUNDS))	// obj bekannt?
		{
			VisualObj result = new VisualObj(obj.getTime(), obj.getCode());
			result = getLineUp(ourGoal, obj, P_GOALIECIRCLE);
			return result;
		}
		else	// obj nicht bekannt
		{
			VisualObj result = new VisualObj(self.getTime(), "home");
			result.setXpos(playX);
			result.setYpos(playY);
			result = evalRel(result, self);
			return result;
		}	
	}
	
	/** siehe TheBrain
	 */	
	int getDesicion()
	{
		target = getBestTarget();
		if(ball == null)	// ball bekannt?
		{
				assignment = P_WAIT;
				if(showCMD) System.out.println(currSee.getTime() + "\tGoalieBrain - assignment: Suchen");
		}
		else if(ball.getDist() <= P_GOALIEATT)	// ball im raum?
		{
			if(ball.getDist() != OUTBOUNDS)	// ballentfernung bekannt?
			{
				mtarget = predictBall(ball, self);
				if((ball.getDist() <= P_MAXBALLCATCHDIST)	// in Fangdistanz?
					&& (ball.getAngle() <= P_MAXBALLCATCHANGLE)	// in Fangwinkel?
					&& (rPlayMode == PLAY_ON))
				{
					assignment = P_CATCH;
					if(showCMD) System.out.println(currSee.getTime() + "\tGoalieBrain - assignment: FANGEN");
				}
				else if(ball.getDist() > P_MAXBALLSHOOTDIST)	// in Schussdistanz?
				{
					assignment = P_MOVETO;
					if(showCMD) System.out.println(currSee.getTime() + "\tGoalieBrain - assignment: Angriff");
				}
				else	// nein, dann in schussdistanz und drauf...
				{
					assignment = P_ATTACKTO;
					if(showCMD) System.out.println(currSee.getTime() + "\tGoalieBrain - assignment: Schiessen");
				}
			}
			else	// ballentfernung nicht bekannt
			{
				if(showCMD) System.out.println(currSee.getTime() + "\tGoalieBrain - assignment: ??????????");
			}
		}
		else	// ball ausserhalb des raums
		{
			focus = ball;
			mtarget = getFocusWait(ball);
			if(mtarget.getDist() >= P_MAXWTARGETDIST)	// in warteentfernung?
			{
				assignment = P_ATTACKTO + P_MOVETO;
				if(showCMD) System.out.println(currSee.getTime() + "\tGoalieBrain - assignment: Ball verfolgen");
			}
			else // angekommen
			{
				assignment = (focus != null) ? (P_FOCUSON) : (P_WAIT);
				if(showCMD) System.out.println(currSee.getTime() + "\tGoalieBrain - assignment: Ball beobachten");
			}
		}
		return assignment;
	}

}
