package robocop;

import java.util.*;

/** Hearevent spezialisiert die MsgEvent Klasse zum Auswerten der Hearnachrichten vom Server
 *
 * @author Paul
 * @author Dirk
 *  
 *
 */
public class HearEvent extends MsgEvent
{
	private int sender = UNKNOWN;
	private double angle = OUTBOUNDS;
	private String hmsg = "";
	private int cmd = UNKNOWN;

	/** Konstruktor
	 * @param message die nicht ausgewertete Hearmessage
	 */	
	public HearEvent(String message)
	{
		super(message);
		time = evalTime(message);
		StringTokenizer	tokenizer = new StringTokenizer(message, " ");
		//skip code and time
		tokenizer.nextToken();
		tokenizer.nextToken();
		String st = tokenizer.nextToken();
		if(st.equals("referee"))
		{
			hmsg = tokenizer.nextToken();
			hmsg = hmsg.substring(0, hmsg.length() - 1);
			sender = REFEREE;
			cmd = evalPlayMode(hmsg);
		}
		else if(st.equals("online_coach_right")) sender = COACHRIGHT;
		else if(st.equals("online_coach_left")) sender = COACHLEFT;
		else if(st.equals("self")) sender = SELF;
		else
		{
			hmsg = message.substring(message.indexOf('"') + 1 , this.message.length() - 2);
			sender = OTHER;
			try
			{
				angle = Double.parseDouble(st);
			}
			catch(NumberFormatException ne)
			{
				if(debug)
				{
					System.out.println("!EXCEPTION! - HearEvent - angle");
					ne.printStackTrace();
				}
				angle = OUTBOUNDS;
			}
		}
	}

	/** gibt den Absender der Nachricht
	 * @return gibt den Absender der Nachricht als Integer zuruek (siehe Konstanten.java)
	 */	
	public int getSender()
	{
			return sender;
	}

	/** Gibt die Richtung des Spielers der Nachricht an
	 * @return Richtung in Grad
	 */	
	public double getAngle()
	{
			return angle;
	}

	/** Gibt die gehoerte Nachricht zuruek
	 * @return Gibt die Nachricht als String zurueck
	 */	
	public String getHMsg()
	{
			return hmsg;
	}

	/** Hier wird die Anweisung des Referees zureuckgegeben
	 * @return Referee Anweisung als Integer (siehe Konstanten.java)
	 */	
	public int getCmd()
	{
			return cmd;
	}

}
