package robocop;
/**
 * <p>Beschreibung: Speichert die anfnglichen Initinfos des spielers,
 *                  die Serverparams und Playerparams</p>
 *
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Uni Mannheim</p>
 * @author Christian
 * @version 1.0
 *
 */
import java.util.*;

public class InitEvent extends MsgEvent
{
	//Variablen fuer die init messages
	private int initPlayMode;
	private int side;
	private int severPlayerNum;

	/**
	 * Konstruktor, zerlegt die init-message, bergibt die message der oberklasse
	 * @param message der vom Server erhaltene "Init"-String
	 */
	public InitEvent(String message)
	{
		super(message);
		time = evalTime(message);

		StringTokenizer	tokenizer = new StringTokenizer(message, " ");
		//skip init-String
		tokenizer.nextToken();

		//eigene-Tor-Seite l oder r
		String sTemp = tokenizer.nextToken();
		side = (sTemp.charAt(0) == 'l') ? LEFTSIDE : RIGHTSIDE;

		//Rcken-Nummer des Spielers
		severPlayerNum = Integer.parseInt(tokenizer.nextToken());

		//Init-PlayMode
		sTemp = tokenizer.nextToken();
		sTemp = sTemp.substring(0,sTemp.length()-1);
		initPlayMode = evalPlayMode(sTemp);
	}

	/**
	 * Liefert die Seite, zu der der Spieler gehrt
	 */
	public int getSide()
	{
		return side;
	}

	/**
	 * Liefert die Rckennummer, die der Spieler vom Server erhalten hat
	 */
	public int getServerPlayerNr(){
		return severPlayerNum;
	}

	/**
	 * Liefert die Zeit, zu der eine Message erhalten wurde
	 * @param serverMessage Der String der vom Server erhalten wurde
	 */
	int evalTime(String serverMessage)
	{
				int sp1 = serverMessage.indexOf(" ");
				int sp2 = serverMessage.indexOf(" ", sp1 + 1);
				int sp3 = serverMessage.indexOf(" ", sp2 + 1);
				return Integer.parseInt(serverMessage.substring(sp2 + 1, sp3));
	}

}//end class
