package robocop;
/**
 * Dieses interface enthlt alle bentigten Konstanten, die vom
 * Server verstanden bzw. gesendet werden
 *
 * @author <a href="mailto:jgruentj@uni-mannheim.de">Jens Grntjes</a><br>
 * @author <a href="mailto:miebert@uni-mannheim.de">Michael Ebert</a><br>
 * @author <a href="mailto:christiansei@gmx.de">Christian Seifried</a>
 * @version 1.57
 *
 */

public interface Konstanten
{
	//Debug?
	public static final boolean debug = false;

	//
	public static final double OUTBOUNDS = Double.POSITIVE_INFINITY;
	public static final int UNKNOWN = -1;

	//Spielzustaende
	public static final int START  = 1;
	public static final int PLAYING = 2;
	public static final int LEFTSIDE = 1;
	public static final int RIGHTSIDE = -1;

	//Spielerauftraege
	public static final int P_WAIT = 0;
	public static final int P_FOCUSON = 1;
	public static final int P_MOVETO = 2;
	public static final int P_ATTACKTO = 4;
	public static final int P_DEFENSETO = 8;
	public static final int P_CATCH = 16;
	public static final int P_MOVEXY = 32;

	//KI-Parameter
	public static final double P_SEEKANGLE = 28;	// drehwinkel zum suchen
	public static final double P_MAXDELTATIME = 4;	// max zeitdifferenz zur vorherberechnung
	public static final double P_MAXFOCUSANGLE = 4;	// max winkel zum beobachten
	public static final double P_MAXMTARGETANGLE = 12;	// max winkel zum anlaufen
	public static final double P_MAXMTARGETDIST = 0.3;	// max entfernung zum laufen
	public static final double P_MAXWTARGETDIST = 0.8;	// max entfernung zum warten
	public static final double P_LINEUPVL = -2;	// annaeherungsentfernung
	public static final double P_MAXATTACKDIST = 18;	// max entfernung zum angreifen
	public static final double P_MAXTELLDIST = 30;	// max entfernung zum mitteilen
	public static final double P_MAXOFFTARGETSHOOTANGLE = 180;	// max winkel zwischen ziel und ball sum schiessen
	public static final double P_MAXBALLSHOOTDIST = 0.6;	// max entfernung zum schiessen
	public static final double P_MAXBALLCATCHDIST = 1.8;	// max entfernung zum fangen
	public static final double P_MAXBALLCATCHANGLE = 90;	// max winkel zum fangen
	public static final double P_BALLPREDICT = 0.9;	// geschwindigkeitsverminderung zum vorherberechnen des balls
	public static final double P_GOALIEATT = 9.5;	// Attackradius des Goalie
	public static final double P_BALLPREDF = 2.0;	// Vorherprojektionsfaktor
	public static final double P_GOALIECIRCLE = 5.5;	// Halbkreis ums Tor
	
	

	//Konstanten fr empfangene Servernachrichten
	public static final int ERROR = -2;
//	public static final int UNKNOWN = -1;
	public static final int SENSEBODY = 0;
	public static final int SEE = 1;
	public static final int HEAR = 2;
	public static final int SERVERPARAM = 3;
	public static final int PLAYERPARAM = 4;
	public static final int INIT = 5;

	//Konstanten fr die Sicht
	public static final int NARROW = 0;
	public static final int NORMAL = 1;
	public static final int WIDE = 2;
	public static final int LOW = 0;
	public static final int HIGH = 1;

	//Konstanten fr Message-Laengen
	public static final int BODYSENSE_LENGTH = 16;

	//Konstannten fr Hear-Sender
	public static final int SELF = 0;
	public static final int REFEREE = 1;
	public static final int COACHLEFT = 2;
	public static final int COACHRIGHT = 3;
	public static final int OTHER = 4;

	//Konstanten fuer Referee-Messages
	public static final int BEFORE_KICK_OFF         =  0;
	public static final int CORNER_KICK_RIGHT       =  1;
	public static final int CORNER_KICK_LEFT        =  2;
	public static final int DROP_BALL               =  3;
	public static final int FREE_KICK_RIGHT         =  4;
	public static final int FREE_KICK_LEFT          =  5;
	public static final int FOUL_RIGHT              =  6;
	public static final int FOUL_LEFT               =  7;
	public static final int GOALIE_CATCH_BALL_RIGHT =  8;
	public static final int GOALIE_CATCH_BALL_LEFT  =  9;
	public static final int GOAL_KICK_RIGHT         = 10;
	public static final int GOAL_KICK_LEFT          = 11;
	public static final int GOAL_RIGHT              = 12;
	public static final int GOAL_LEFT               = 13;
	public static final int HALFTIME                = 14;
	public static final int KICK_IN_RIGHT           = 15;
	public static final int KICK_IN_LEFT            = 16;
	public static final int KICK_OFF_RIGHT          = 17;
	public static final int KICK_OFF_LEFT           = 18;
	public static final int OFFSIDE_RIGHT           = 19;
	public static final int OFFSIDE_LEFT            = 20;
	public static final int PLAY_ON                 = 21;
	public static final int TIME_EXTENDED           = 22;
	public static final int TIME_OVER               = 23;
	public static final int TIME_UP                 = 24;
	public static final int TIME_UP_WITHOUT_A_TEAM  = 25;


//	Spielerpositionen und Bereiche
//	{Xpos  / Ypos  / PlayX / PlayY / MinX  / MaxX  / MinY  / MaxY}
	public static final double[][] PINIT =
	{{-49.00,  01.00, -51.00,  00.00, -57.50, -30.00, -15.00,  15.00},	//0
	 {-45.00, -16.00, -36.00, -16.00, -57.50, -18.00, -39.00, -15.00},	//1
	 {-40.00, -02.50, -34.00, -02.50, -57.50, -18.00, -17.00,  02.00},	//2
	 {-40.00,  02.50, -34.00,  02.50, -57.50, -18.00, -02.00,  17.00},	//3
	 {-45.00,  16.00, -36.00,  16.00, -57.50, -18.00,  15.00,  39.00},	//4
	 {-15.00, -12.50,  00.00, -22.70, -30.00,  18.00, -39.00, -10.00},	//5
	 {-15.00,  00.00,  03.50,  00.00, -30.00,  18.00, -12.50,  12.50},	//6
	 {-15.00,  12.50,  00.00,  22.70, -30.00,  18.00,  10.00,  39.00},	//7
	 {-00.50, -10.70,  27.00, -12.50,  08.00,  57.50, -39.00, -00.00},	//8
	 {-00.80,  00.00,  30.00,  00.00,  08.00,  57.50, -08.00,  08.00},	//9
	 {-00.50,  10.70,  27.00,  12.50,  08.00,  57.50,  00.00,  39.00}};	//10

	/*2-dim Array, das die absoluten X/Y Werte der Flaggen hat
	 *zeile gibt flaggennr an, die 1.spalte den x-wert, die 2.spalte den y-wert
	 * flagge [nr] [0] - x-wert
	 * flagge [nr] [1] - y-wert
	 */
	public static final double[][] FLAGSXY =
		{{-50,-39},
		{-40,-39},
		{-30,-39},
		{-20,-39},
		{-10,-39},
		{0,-39},
		{10,-39},
		{20,-39},
		{30,-39},
		{40,-39},
		{50,-39}, //bis hierhin obere uere linie
		{-52.5,-34}, //flag-nr 11
		{0,-34},
		{52.5,-34},//bis hierhin obere innere linie
		{-57.5,-30},
		{57.5,-30}, //flag-nr 15
		{-57.5,-20},
		{-36,-20},
		{36,-20},
		{57.5,-20},
		{-57.5,-10}, //flag-nr 20
		{57.5,-10},
		{-52.5,-7.01},
		{52.5,-7.01}, //torposten oben (bei spiel von links nach rechts)
		{-57.5,0}, //flag-nr 24
		{-52.5,0},//linkes Tor
		{-36,0},
		{0,0}, //mittelpkt flag-nr 27
		{36,0},
		{52.5,0},//rechtes Tor mitte nr.29
		{57.5,0},
		{-52.5,7.01},
		{52.5,7.01},//flag-nr 32 torpfosten unten (bei spiel von links nach rechts)
		{-57.5,10},
		{57.5,10},
		{-57.5,20},
		{-36,20},
		{36,20}, //flag-nr 37
		{57.5,20},
		{-57.5,30},
		{57.5,30},
		{-52.5,34}, //hier beginnt untere innere linie
		{0,34},
		{52.5,34}, //flag-nr 43
		{-50,39},  //hier beginnt die uere untere linie
		{-40,39},
		{-30,39},
		{-20,39},
		{-10,39},
		{0,39}, //flag-nr 49
		{10,39},
		{20,39},
		{30,39},
		{40,39},
		{50,39}}; //flag-nr 54
}
