package robocop;
/**
 * <p>berschrift: robocup Soccer Client</p>
 * <p>Beschreibung: Fussball Client fuer den RCSS</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Uni Mannheim</p>
 * @author Christian Seifried
 * @version 1.0
 */

import java.util.*;

public class Player extends Thread implements Konstanten
{

	private String teamName;
	private String serverName;
	private int serverPort;
	private TheBrain theBrain = null;
	private NetTraffic netTraffic = null;

	/**
	 * <p>Konstruktor: Hier wird eine neue Instanz des Players erzeugt.</p>
	 *
	 * @param servername Name des Servers
	 * @param serverport ServerPort auf den der Server zu beginn lauscht
	 * @param teamName Name der Mannschaft, fr die gespielt wird
	 * @param Gui, an oder aus fuer diesen client
	 */

	public Player(String servername, int serverport, String teamName, int playerNumber, int Gui)
	{
		this.teamName = teamName;
		this.serverName = servername;
		this.serverPort = serverport;

		//Klasse fr die Netzwerkkommunik.
		netTraffic = new NetTraffic(servername, serverport);

		//Klasse fuer die KI
		if (playerNumber == 1) theBrain = (TheBrain)new GoalieBrain(netTraffic, teamName, playerNumber, Gui);
		else theBrain = (TheBrain)new PlayerBrain(netTraffic, teamName, playerNumber, Gui);

	}// end Konstruktor

	/**
	 * Diese Methode berschreibt run() von der Klasse Thread, sie wird implizit von der
	 * methode start() dieser klasse aufgerufen.
	 *
	 */
	public void run()
	{
		// Anmelden des Spielers am Server und los gehts
		theBrain.handleEvent();
	}//end run


	/**
	 * Diese Funktion wird beim Programmstart aufgerufen und
	 * startet den Client
	 *
	 * @param args Die Argumente sind <code>SERVERNAME SERVERPORT TEAMNAME</code>
	 */

	public static void main (String[] args)
	{
		String serverName = (args.length > 0) ? (args[0]) : ("localhost");
		int serverPort = (args.length > 1) ? (Integer.parseInt(args[1])) : (6000);
		String teamName = (args.length > 2) ? (args[2]) : ("Team_A");
		String teamName2 = "Team_B";
		int playerNr = (args.length > 3) ? (Integer.parseInt(args[3])) : (1);
		int showGUI = (args.length > 4) ? (Integer.parseInt(args[4])) : (0);
		showGUI = (args.length < 4) ? (1) : (showGUI);

		if((playerNr >= 1)
			&& (playerNr <= 11)
			&& (showGUI >= 0)
			&& (showGUI <= 1)
			&& (serverPort >= 1)
			&& (serverPort <= 65535))
		{
			if(args.length > 3)
			{
				Player player1 = new Player(serverName, serverPort, teamName, playerNr, showGUI);
				player1.start();
			}
			else if((args.length == 0) || (args.length == 2) || (args.length == 3))
			{
/*
 */
				Player playerA1 = new Player(serverName, serverPort, teamName, 1, 0);
				playerA1.start();
				Player playerA2 = new Player(serverName, serverPort, teamName, 2, 0);
				playerA2.start();
				Player playerA3 = new Player(serverName, serverPort, teamName, 3, 0);
				playerA3.start();
				Player playerA4 = new Player(serverName, serverPort, teamName, 4, 0);
				playerA4.start();
				Player playerA5 = new Player(serverName, serverPort, teamName, 5, 0);
				playerA5.start();
				Player playerA6 = new Player(serverName, serverPort, teamName, 6, 0);
				playerA6.start();
				Player playerA7 = new Player(serverName, serverPort, teamName, 7, showGUI);
				playerA7.start();
				Player playerA8 = new Player(serverName, serverPort, teamName, 8, 0);
				playerA8.start();
				Player playerA9 = new Player(serverName, serverPort, teamName, 9, 0);
				playerA9.start();
				Player playerA10 = new Player(serverName, serverPort, teamName, 10, 0);
				playerA10.start();
				Player playerA11 = new Player(serverName, serverPort, teamName, 11, 0);
				playerA11.start();
/*
 */
				if(args.length < 3)
				{
/*
 */
					Player playerB1 = new Player(serverName, serverPort, teamName2, 1, 0);
					playerB1.start();
					Player playerB2 = new Player(serverName, serverPort, teamName2, 2, 0);
					playerB2.start();
					Player playerB3 = new Player(serverName, serverPort, teamName2, 3, 0);
					playerB3.start();
					Player playerB4 = new Player(serverName, serverPort, teamName2, 4, 0);
					playerB4.start();
					Player playerB5 = new Player(serverName, serverPort, teamName2, 5, 0);
					playerB5.start();
					Player playerB6 = new Player(serverName, serverPort, teamName2, 6, 0);
					playerB6.start();
					Player playerB7 = new Player(serverName, serverPort, teamName2, 7, 0);
					playerB7.start();
					Player playerB8 = new Player(serverName, serverPort, teamName2, 8, 0);
					playerB8.start();
					Player playerB9 = new Player(serverName, serverPort, teamName2, 9, 0);
					playerB9.start();
					Player playerB10 = new Player(serverName, serverPort, teamName2, 10, 0);
					playerB10.start();
					Player playerB11 = new Player(serverName, serverPort, teamName2, 11, 0);
					playerB11.start();
/*
 */
				}
			}
		}
		else
		{
			System.out.println("Parameter falsch:\n\tSERVERNAME PORT TEAMNAME SPIELERNUMMER GUI[0/1]  -  Einzelspieler");
			System.out.println("oder\tSERVERNAME PORT TEAMNAME SPIELERNUMMER  -  Einzelspieler");
			System.out.println("oder\tSERVERNAME PORT TEAMNAME  -  Mannschaft");
			System.out.println("oder\tSERVERNAME PORT  -  Demomodus");
			System.out.println("oder\t[]  -  Demomodus");
			System.exit(1);
		}
	}
}//end class