
package robocop;

/** Erweiterte Feldspieler KI
 *
 * @author Paul
 * @author Dirk
 * @see TheBrain
 */
public class PlayerBrain extends TheBrain
{
	
	/** siehe TheBrain
	 * @param netTraffic
	 * @param teamName
	 * @param playerNumber
	 * @param gui
	 */
	public PlayerBrain(NetTraffic netTraffic, String teamName, int playerNumber, int gui)
	{
		super(netTraffic, teamName, playerNumber, gui);
	}

	/** siehe TheBrain
	 */	
	double getKickStrength(VisualObj target)
	{
		if((target != null) && (target.getDist() != OUTBOUNDS))
		{
			if(target.getDist() > 50) return 100;
			else if(target.getDist() > 30) return 100;
			else if(target.getDist() > 10) return 85;
			else if(target.getDist() > 5) return 75;
			else if(target.getDist() > 1) return 65;
			else return 50;
		}
		else return 20;
	}

	/** siehe TheBrain
	 */	
	double getDashStrength(VisualObj target)
	{
		if((target != null) && (target.getDist() != OUTBOUNDS))
		{
			if(target.getDist() > 25) return 100;
			else if(target.getDist() > 15) return 100;
			else if(target.getDist() > 7) return 100;
			else if(target.getDist() > 3) return 100;
			else if(target.getDist() > 1.5) return 100;
			else if(target.getDist() > 0.5) return 75;
			else return 50;
		}
		else return 0;
	}

			
	
	/**
	 */	
	VisualObj getFocusWait(VisualObj obj)
	{
		if((obj != null)
			&& (obj.getXpos() != OUTBOUNDS)
			&& (obj.getYpos() != OUTBOUNDS))	// obj bekannt?
		{
			VisualObj result = new VisualObj(obj.getTime(), obj.getCode());
			double fx = obj.getXpos();
			double fy = obj.getYpos();

			fx = (fx > maxX) ? (maxX) : (fx);
			fx = (fx < minX) ? (minX) : (fx);
			if(obj.getDist() <= P_MAXATTACKDIST)	// objekt in angriffsweite?
			{
				fy = (fy > maxY) ? (maxY) : (fy);
				fy = (fy < minY) ? (minY) : (fy);
			}
			else
			{
				fx = playX;
				fy = playY;
			}
			result.setXpos(fx);
			result.setYpos(fy);
			result = evalRel(result, self);
			return result;
		}
		else	// obj nicht bekannt
		{
			VisualObj result = new VisualObj(self.getTime(), "home");
			result.setXpos(playX);
			result.setYpos(playY);
			result = evalRel(result, self);
			return result;
		}
	}

	/** siehe TheBrain
	 */	
	VisualObj getBestTarget()
	{
		if((rPlayMode == KICK_OFF_RIGHT)
		 || (rPlayMode == KICK_OFF_LEFT)
		 || (rPlayMode == GOAL_RIGHT)
		 || (rPlayMode == GOAL_LEFT))
		return getLineUp(ball, ourGoal, 3);
		else return enemyGoal;
	}

	/** siehe TheBrain
	 */	
	int getDesicion()
	{
		target = getBestTarget();
		if(ball == null)	// ball bekannt?
		{
				assignment = P_WAIT;
				if(showCMD) System.out.println(currSee.getTime() + "\tPlayerBrain - assignment: Suchen");
		}
		else if(isInBounds(ball))	// ball im raum?
		{
			if(ball.getDist() != OUTBOUNDS)	// ballentfernung bekannt?
			{
				mtarget = predictBall(ball, self);
//				if(mtarget.getDist() > (Math.abs(P_LINEUPVL) + P_MAXMTARGETDIST) * 1.2) mtarget = getLineUp(mtarget, target, P_LINEUPVL);
				if(ball.getDist() > P_MAXBALLSHOOTDIST)	// in Schussdistanz?
				{
					assignment = P_MOVETO;
					if(showCMD) System.out.println(currSee.getTime() + "\tPlayerBrain - assignment: Angriff");
				}
				else	// nein, dann in schussdistanz und drauf...
				{
					assignment = P_ATTACKTO;
					if(showCMD) System.out.println(currSee.getTime() + "\tPlayerBrain - assignment: Schiessen");
				}
			}
			else	// ballentfernung nicht bekannt
			{
				if(showCMD) System.out.println(currSee.getTime() + "\tPlayerBrain - assignment: ??????????");
			}
		}
		else	// ball ausserhalb des raums
		{
			focus = ball;
			mtarget = getFocusWait(ball);
			if(mtarget.getDist() >= P_MAXWTARGETDIST)	// in warteentfernung?
			{
				assignment = P_ATTACKTO + P_MOVETO;
				if(showCMD) System.out.println(currSee.getTime() + "\tPlayerBrain - assignment: Ball verfolgen");
			}
			else // angekommen
			{
				assignment = (focus != null) ? (P_FOCUSON) : (P_WAIT);
				if(showCMD) System.out.println(currSee.getTime() + "\tPlayerBrain - assignment: Ball beobachten");
			}
		}
		return assignment;
	}

}
