package robocop;

/** Klasse zum Erfassen aller sichtbaren Objekte
 * Die einzelnen Methoden lesen/setzen die entsprechenden Zustandsparameter
 */
public class VisualObj implements Konstanten
{
	private int     time = UNKNOWN;
	private String  code = "";
	private double  dist = OUTBOUNDS;
	private double  angle= OUTBOUNDS;
	private double  xpos = OUTBOUNDS;
	private double  ypos = OUTBOUNDS;
	private double  deltax = 0;
	private double  deltay = 0;

	VisualObj(int time, String code)
	{
		this.time  = time;
		this.code  = code;
	}

	VisualObj(int time, String code, double dist, double angle)
	{
		this.time  = time;
		this.code  = code;
		this.dist  = dist;
		this.angle = angle;
	}

	VisualObj(int time, String code, double dist, double angle, double xpos, double ypos)
	{
		this.time  = time;
		this.code  = code;
		this.dist  = dist;
		this.angle = angle;
		this.xpos  = xpos;
		this.ypos  = ypos;
	}

	VisualObj(int time, String code, double dist, double angle, double xpos, double ypos, double deltax, double deltay)
	{
		this.time  = time;
		this.code  = code;
		this.dist  = dist;
		this.angle = angle;
		this.xpos  = xpos;
		this.ypos  = ypos;
		this.deltax  = deltax;
		this.deltay  = deltay;
	}

	/**
	 * @return  */	
	public int    getTime()		{return time;}
	/**
	 * @return  */	
	public String getCode()		{return code;}
	/**
	 * @return  */	
	public double getDist()		{return dist;}
	/**
	 * @param
	 */	
	public double getAngle()	{return angle;}
	/**
	 * @return  */	
	public double getXpos()		{return xpos;}
	/**
	 * @return  */	
	public double getYpos()		{return ypos;}
	/**
	 * @return  */	
	public double getDeltaX()	{return deltax;}
	/**
	 * @return  */	
	public double getDeltaY()	{return deltay;}

	/**
	 * @param time  */	
	public void setTime(int time)					{this.time  = time;}
	/**
	 * @param code  */	
	public void setCode(String code)			{this.code  = code;}
	/**
	 * @param dist  */	
	public void setDist(double dist)			{this.dist  = dist;}
	/**
	 * @param angle  */	
	public void setAngle(double angle)		{this.angle = angle;}
	/**
	 * @param xpos  */	
	public void setXpos(double xpos)			{this.xpos  = xpos;}
	/**
	 * @param ypos  */	
	public void setYpos(double ypos)			{this.ypos  = ypos;}
	/**
	 * @param deltax  */	
	public void setDeltaX(double deltax)	{this.deltax  = deltax;}
	/**
	 * @param deltay  */	
	public void setDeltaY(double deltay)	{this.deltay  = deltay;}
}
